// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.*;
import greenfoot.*;

/**
 * A pen is a circle. You can draw with the circle by clicking and dragging. Rezise or change color.
 */
public class Pen extends Actor
{
    private MouseInfo mouseInfo;
    private ColorPickerActor colorPickerActor =  new  ColorPickerActor();
    /* Saves the color that is picked when you press the key "c" and click on a color. Start color Yellow.*/
    private Color colorPicked = Color.YELLOW;
    private boolean penDown = false;
    /* Indicates if you are chose a color in the moment or not.*/
    private boolean colorPickerOn = false;
    /* Pen: start size*/
    private double size = 50;
    private int posX;
    private int posY;
    /* variable for penBlinksBrighterDarker() loop*/
    private int n;

    /**
     * 
     */
    protected void addedToWorld(World MyWorld)
    {
        setPen((int)size, "oval", colorPicked);
    }

    /**
     * Act - tut, was auch immer MousePensel tun will. Diese Methode wird aufgerufen, sobald der 'Act' oder 'Run' Button in der Umgebung angeklickt werden.
     */
    public void act()
    {
        mouseInfo = Greenfoot.getMouseInfo();
        if (penDown == false) {
            setPenSignalsPenUp((int)size, "oval", colorPicked);
        }
        if (Greenfoot.isKeyDown("c") || colorPickerOn) {
            pickColor();
        }
        if (Greenfoot.isKeyDown("-") || Greenfoot.isKeyDown("+")) {
            resizePen();
        }
        if ( ! colorPickerOn) {
            /* Change the penDown-boolean by double-clicking.*/
            if (Greenfoot.mouseClicked(this) && mouseInfo.getClickCount() == 2) {
                if (penDown == false) {
                    penDown = true;
                    setPen((int)size, "oval", colorPicked);
                    n = 0;
                }
                else {
                    penDown = false;
                }
            }
            /* Draw one circle by one click.*/
            if (Greenfoot.mouseClicked(this) && penDown == true) {
                getWorld().getBackground().setColor(colorPicked);
                getWorld().getBackground().fillOval(getMouseX() - (int)size / 2, getMouseY() - (int)size / 2, (int)size, (int)size);
            }
            if (Greenfoot.mouseDragged(this)) {
                drawCircleORchangeLocation();
            }
        }
    }

    /**
     * A image appears where you can select a color by mouseclick.
     */
    public void pickColor()
    {
        if (Greenfoot.isKeyDown("c")) {
            GreenfootImage colorPicker =  new  GreenfootImage("colorPicker.png");
            /* colorPicker.fillRect will perform the necessary internal initialisation for getColorAt to later work*/
            colorPicker.fillRect(0, 0, 0, 0);
            colorPickerActor.setImage(colorPicker);
            getWorld().addObject(colorPickerActor, getWorld().getWidth() / 2, getWorld().getHeight() / 2);
            colorPickerOn = true;
        }
        if (Greenfoot.mouseClicked(colorPickerActor)) {
            colorPicked = colorPickerActor.getImage().getColorAt(mouseInfo.getX() - (getWorld().getWidth() - 548) / 2, mouseInfo.getY() - (getWorld().getHeight() - 372) / 2);
            getWorld().removeObject(colorPickerActor);
            setPen((int)size, "oval", colorPicked);
            colorPickerOn = false;
        }
    }

    /**
     * check Key. and change pencil size
     */
    public void resizePen()
    {
        double strengthOfChange = 0.007;
        int delayControl = 0;
        while (Greenfoot.isKeyDown("+") || Greenfoot.isKeyDown("-")) {
            if (Greenfoot.isKeyDown("-") && size > 2) {
                size = size - size * strengthOfChange;
            }
            if (Greenfoot.isKeyDown("+") && size < 1.5 * getWorld().getWidth()) {
                size = size + size * strengthOfChange;
            }
            setPen((int)size, "oval", colorPicked);
            if (delayControl % 5 == 0) {
                Greenfoot.delay(1);
            }
            delayControl = delayControl + 1;
        }
    }

    /**
     * Set the image and size of pen.
     */
    public void setPen(int size, String shape, Color color)
    {
        GreenfootImage penImage =  new  GreenfootImage(size, size);
        penImage.setColor(color);
        penImage.fillOval(0, 0, size, size);
        penImage.setColor(Color.BLACK);
        penImage.drawOval(0, 0, size, size);
        setImage(penImage);
    }

    /**
     * Set the image and size of pen.
     */
    public void setPenSignalsPenUp(int size, String shape, Color color)
    {
        GreenfootImage penImage =  new  GreenfootImage(size, size);
        penImage.setColor(color);
        penImage.fillOval(0, 0, size, size);
        penImage.setColor(Color.BLACK);
        penImage.drawOval(0, 0, size, size);
        /* draws black oval with 2/5 size in the pen to indicate that the pen is up (you can't draw).*/
        int x = (int)size / 5;
        penImage.drawOval(x, x, size - 2 * x, size - 2 * x);
        setImage(penImage);
    }

    /**
     * Draw a circle or set the location to mouse-position
     */
    public void drawCircleORchangeLocation()
    {
        setLocation(getMouseX(), getMouseY());
        if (Greenfoot.mouseDragged(this) && penDown == true) {
            getWorld().getBackground().setColor(colorPicked);
            getWorld().getBackground().fillOval(getMouseX() - (int)size / 2, getMouseY() - (int)size / 2, (int)size, (int)size);
        }
    }

    /**
     * 
     */
    public int getMouseX()
    {
        return Greenfoot.getMouseInfo().getX();
    }

    /**
     * 
     */
    public int getMouseY()
    {
        return Greenfoot.getMouseInfo().getY();
    }
}
